#!/usr/bin/env node
/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	// The require scope
/******/ 	var __webpack_require__ = {};
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};

;// CONCATENATED MODULE: ./node_modules/ansi-es6/out/ansi.js
/**
 * Creates a basic ANSI escape code string from one or more numeric codes.
 * @param codes Numeric ANSI escape codes.
 */
const code = (...codes) => `\x1b[${codes.join(';')}m`;
/**
 * Adds ANSI escape codes to a string.
 * Resets **all** properties at the end of the string.
 * @param text Text to colorize.
 * @param modifiers ANSI escape code modifiers.
 */
const modify = (text, ...modifiers) => modifiers.join('') + text + code(0);
/** [0] Resets all attributes. */
const Reset = code(0);
/** [1] */
const Bold = code(1);
/** [2] */
const Faint = code(2);
/** [3] */
const Italic = code(3);
/** [4] */
const Underline = code(4);
/** [5] */
const BlinkSlow = code(5);
/** [6] */
const BlinkRapid = code(6);
/** [7] Swaps foreground and background colors. */
const ReverseVideo = code(7);
/** [8] */
const Conceal = code(8);
/** [9] */
const CrossedOut = code(9);
/** [10] */
const PrimaryFont = code(10);
/** [11] */
const AlternativeFont1 = code(11);
/** [12] */
const AlternativeFont2 = code(12);
/** [13] */
const AlternativeFont3 = code(13);
/** [14] */
const AlternativeFont4 = code(14);
/** [15] */
const AlternativeFont5 = code(15);
/** [16] */
const AlternativeFont6 = code(16);
/** [17] */
const AlternativeFont7 = code(17);
/** [18] */
const AlternativeFont8 = code(18);
/** [19] */
const AlternativeFont9 = code(19);
/** [20] */
const Fraktur = code(20);
/** [21] */
const DoublyUnderline = code(21);
/** [22] */
const NormalColorOrIntensity = code(22);
/** [23] */
const NotItalicOrFraktur = code(23);
/** [24] */
const UnderlineOff = code(24);
/** [25] */
const BlinkOff = code(25);
/** [27] */
const InverseOff = code(27);
/** [28] */
const Reveal = code(28);
/** [29] */
const NotCrossedOut = code(29);
/** [51] */
const Framed = code(51);
/** [52] */
const Encircled = code(52);
/** [53] */
const Overlined = code(53);
/** [54] */
const NotFramedOrEncircled = code(54);
/** [55] */
const NotOverlined = code(55);
/** [60] */
const IdeogramUnderline = code(60);
/** [61] */
const IdeogramDoubleUnderline = code(61);
/** [62] */
const IdeogramOverline = code(62);
/** [63] */
const IdeogramDoubleOverline = code(63);
/** [64] */
const IdeogramStressMarking = code(64);
/** [65] */
const IdeogramAttributesOff = code(65);
/** [30] */
const FgBlack = code(30);
/** [31] */
const FgRed = code(31);
/** [32] */
const FgGreen = code(32);
/** [33] */
const FgYellow = code(33);
/** [34] */
const FgBlue = code(34);
/** [35] */
const FgMagenta = code(35);
/** [36] */
const FgCyan = code(36);
/** [37] */
const FgWhite = code(37);
/** [90] */
const FgBrightBlack = code(90);
/** [91] */
const FgBrightRed = code(91);
/** [92] */
const FgBrightGreen = code(92);
/** [93] */
const FgBrightYellow = code(93);
/** [94] */
const FgBrightBlue = code(94);
/** [95] */
const FgBrightMagenta = code(95);
/** [96] */
const FgBrightCyan = code(96);
/** [97] */
const FgBrightWhite = code(97);
/** [39] */
const FgDefault = code(39);
/** [40] */
const BgBlack = code(40);
/** [41] */
const BgRed = code(41);
/** [42] */
const BgGreen = code(42);
/** [43] */
const BgYellow = code(43);
/** [44] */
const BgBlue = code(44);
/** [45] */
const BgMagenta = code(45);
/** [46] */
const BgCyan = code(46);
/** [47] */
const BgWhite = code(47);
/** [100] */
const BgBrightBlack = code(100);
/** [101] */
const BgBrightRed = code(101);
/** [102] */
const BgBrightGreen = code(102);
/** [103] */
const BgBrightYellow = code(103);
/** [104] */
const BgBrightBlue = code(104);
/** [105] */
const BgBrightMagenta = code(105);
/** [106] */
const BgBrightCyan = code(106);
/** [107] */
const BgBrightWhite = code(107);
/** [49] */
const BgDefault = code(49);
/**
 * Creates an RGB modifier for the foreground.
 * [38;2;r;g;b]
 * @param r Red channel value (0 to 255).
 * @param g Green channel value (0 to 255).
 * @param b Blue channel value (0 to 255).
 */
const FgRgb = (r, g, b) => code(38, 2, r, g, b);
/**
 * Creates an RGB modifier for the background.
 * [48;2;r;g;b]
 * @param r Red channel value (0 to 255).
 * @param g Green channel value (0 to 255).
 * @param b Blue channel value (0 to 255).
 */
const BgRgb = (r, g, b) => code(48, 2, r, g, b);
/**
 * Convert HSL to RGB.
 * @param h Hue [0, 359]
 * @param s Saturation [0, 1]
 * @param l Lightness [0, 1]
 * @returns RGB values [0, 255] as array.
 */
function hslToRgb(h, s, l) {
    h /= 360;
    let r, g, b;
    if (s == 0) {
        r = g = b = l; // achromatic
    }
    else {
        const hue2rgb = (p, q, t) => {
            if (t < 0)
                t += 1;
            if (t > 1)
                t -= 1;
            if (t < 1 / 6)
                return p + (q - p) * 6 * t;
            if (t < 1 / 2)
                return q;
            if (t < 2 / 3)
                return p + (q - p) * (2 / 3 - t) * 6;
            return p;
        };
        const q = l < 0.5 ? l * (1 + s) : l + s - l * s;
        const p = 2 * l - q;
        r = hue2rgb(p, q, h + 1 / 3);
        g = hue2rgb(p, q, h);
        b = hue2rgb(p, q, h - 1 / 3);
    }
    return [r, g, b].map(x => Math.round(x * 255));
}
/**
 * Creates an RGB modifier (from HSL) for the foreground.
 * @param h Hue [0, 359]
 * @param s Saturation [0, 1]
 * @param l Lightness [0, 1]
 */
const FgHsl = (h, s, l) => FgRgb(...hslToRgb(h, s, l));
/**
 * Creates an RGB modifier (from HSL) for the background.
 * @param h Hue [0, 359]
 * @param s Saturation [0, 1]
 * @param l Lightness [0, 1]
 */
const BgHsl = (h, s, l) => BgRgb(...hslToRgb(h, s, l));

;// CONCATENATED MODULE: external "command-line-args"
const external_command_line_args_namespaceObject = require("command-line-args");
var external_command_line_args_default = /*#__PURE__*/__webpack_require__.n(external_command_line_args_namespaceObject);
;// CONCATENATED MODULE: external "command-line-usage"
const external_command_line_usage_namespaceObject = require("command-line-usage");
var external_command_line_usage_default = /*#__PURE__*/__webpack_require__.n(external_command_line_usage_namespaceObject);
;// CONCATENATED MODULE: external "readline"
const external_readline_namespaceObject = require("readline");
;// CONCATENATED MODULE: external "undici"
const external_undici_namespaceObject = require("undici");
;// CONCATENATED MODULE: ./src/command-line.ts
const ColorOptionsList = ['auto', 'never', 'always'];
function isValidColorOption(option) {
    return ColorOptionsList.includes(option);
}

;// CONCATENATED MODULE: external "jsdom"
const external_jsdom_namespaceObject = require("jsdom");
;// CONCATENATED MODULE: ./src/parsing.ts

function parse(html) {
    const dom = new external_jsdom_namespaceObject.JSDOM(html);
    const { document, Node } = dom.window;
    const results = [...document.querySelectorAll("#primary .concept_light")]
        .map(block => {
        const jp = block.querySelector('.concept_light-representation');
        if (jp == null)
            throw new Error("Result list not found.");
        const text = jp.querySelector('.text').textContent.trim();
        const items = [...block.querySelector('.meanings-wrapper').children]
            .map(parseItem);
        const textParts = [...jp.querySelector('.text').childNodes]
            .map(e => {
            // Kanji are in text nodes, Kana in <span> elements.
            // Kana appear as single elements, adjacent Kanji exist in the same text node.
            const type = e.nodeType === Node.ELEMENT_NODE ? 'kana' : 'kanji';
            return Array.from(e.textContent.trim()).map(char => ({ text: char, type }));
        })
            .reduce((arr, x) => arr.concat(x), []);
        const furiganaContainer = jp.querySelector('.furigana');
        // If <ruby> is used the furigana are within an <rt> tag.
        const furigana = furiganaContainer.querySelector('ruby') == null
            ? [...furiganaContainer.children].map(e => e.textContent.trim())
            : Array.from(furiganaContainer.querySelector('rt').textContent.trim());
        const reading = furigana
            .map((e, i) => {
            return e == ''
                // If the furigana is empty and the corresponding text is a kanji,
                // the previous furigana already contains the transcription.
                ? (i >= textParts.length || textParts[i].type == 'kanji' ? '' : textParts[i].text)
                : e;
        })
            .join('');
        return { text, reading, items };
    });
    return results;
}
function parseItem(m) {
    if (m.classList.contains('meaning-tags'))
        return {
            type: 'tag',
            text: m.textContent.trim(),
        };
    const meaningElement = m.querySelector('.meaning-meaning');
    const text = meaningElement
        ? meaningElement.textContent.trim()
        : m.textContent.trim();
    const numberElement = m.querySelector('.meaning-definition-section_divider');
    const number = numberElement === null || numberElement === void 0 ? void 0 : numberElement.textContent.trim();
    const supplementalInfoElement = m.querySelector('.supplemental_info');
    const supplementalInfo = supplementalInfoElement == null ? [] :
        [...supplementalInfoElement.querySelectorAll('.sense-tag')]
            .map(st => {
            if (st.classList.contains('tag-tag'))
                return { type: 'tag', text: st.textContent.trim() };
            if (st.classList.contains('tag-see_also')) {
                const link = st.querySelector('a');
                return {
                    type: 'see-also',
                    text: link.textContent.trim(),
                    href: link.href,
                };
            }
            return null;
        })
            .filter(x => x != null);
    return {
        type: 'meaning',
        number, text, supplementalInfo,
    };
}

;// CONCATENATED MODULE: ./package.json
const package_namespaceObject = JSON.parse('{"i8":"0.4.1","cj":{"H":"https://github.com/brunnerh/jisho-cli"}}');
;// CONCATENATED MODULE: ./src/main.ts
var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};








const base = 'https://jisho.org';
const main = () => __awaiter(void 0, void 0, void 0, function* () {
    const definitions = [
        { name: 'help', alias: 'h', type: Boolean, defaultValue: false },
        { name: 'interactive', alias: 'i', type: Boolean, defaultValue: false },
        { name: 'reverse', alias: 'r', type: Boolean, defaultValue: false },
        { name: 'color', alias: 'c', type: String, defaultValue: 'auto' },
        { name: 'term', defaultOption: true, type: String },
    ];
    const { help, interactive, term, reverse: topToBottom, color } = external_command_line_args_default()(definitions);
    if (isValidColorOption(color) == false) {
        console.error(`Invalid value for 'color': ${color}`);
        process.exit(1);
    }
    if (help || interactive == false && term == null) {
        const usage = external_command_line_usage_default()([
            {
                header: 'jisho-cli',
                content: 'Look up a term, English or Japanese, on jisho.org.',
            },
            {
                header: 'Synopsis',
                content: [
                    'jisho-cli [options] {underline term}',
                    'jisho-cli [options] {bold -i} [{underline term}]',
                ]
            },
            {
                header: 'Options',
                optionList: [
                    {
                        alias: 'i',
                        name: 'interactive',
                        description: 'If set, the application executes interactively. Faster when looking up multiple terms.',
                    },
                    {
                        alias: 'c',
                        name: 'color',
                        description: 'Enables or disables color output.' +
                            ' Valid values are: {underline auto} (default), {underline always}, {underline never}.' +
                            '\n{underline auto} enables coloring for TTYs.',
                    },
                    {
                        alias: 'r',
                        name: 'reverse',
                        description: 'Show results top to bottom.',
                    },
                    {
                        alias: 'h',
                        name: 'help',
                        description: 'Print this message.',
                    }
                ]
            }
        ]);
        console.log(usage);
        process.exit(1);
    }
    // To catch Ctrl+D
    external_readline_namespaceObject.emitKeypressEvents(process.stdin);
    if (process.stdin.isTTY)
        process.stdin.setRawMode(true);
    const readInterface = external_readline_namespaceObject.createInterface({
        input: process.stdin,
        output: process.stdout,
        terminal: process.stdin.isTTY,
    });
    const colorize = conditionalModify(useColor(color));
    const question = (q) => new Promise(res => {
        readInterface.question(q, answer => {
            console.log();
            res(answer);
        });
    });
    let needInput = term == null;
    while (true) {
        const rawTerm = needInput ?
            yield question(colorize("Search term: ", FgBrightYellow)) : term;
        const currentTerm = rawTerm.trim();
        if (currentTerm == '')
            break;
        needInput = true;
        if (process.stdout.isTTY)
            process.stdout.write(colorize('Searching...', FgYellow));
        const clr = () => {
            if (process.stdout.isTTY) {
                external_readline_namespaceObject.clearLine(process.stdout, -1);
                external_readline_namespaceObject.cursorTo(process.stdout, 0);
            }
        };
        try {
            const results = yield lookUpTerm(currentTerm);
            clr();
            if (topToBottom == false)
                results.reverse();
            results.forEach(result => {
                console.log(`${colorize(result.text, Bold, FgBrightGreen)} [${colorize(result.reading, FgBrightMagenta)}]:`);
                result.items.forEach(m => {
                    switch (m.type) {
                        case 'meaning':
                            const prefix = m.number === undefined
                                ? ''
                                : (colorize(m.number, Faint) + ' ');
                            const suffix = m.supplementalInfo.length == 0
                                ? ''
                                : (colorize(' - ' + renderInfo(m.supplementalInfo), Faint));
                            console.log(`\t${prefix}${m.text}${suffix}`);
                            break;
                        case 'tag':
                            console.log(`\t${colorize(m.text, FgCyan)}`);
                            break;
                    }
                });
                console.log();
            });
        }
        catch (e) {
            clr();
            console.error("An error occurred fetching the results.");
            console.error(e);
        }
        if (interactive == false)
            break;
    }
    readInterface.close();
});
const useColor = (colorArgument) => {
    switch (colorArgument) {
        case 'auto':
            return 'NO_COLOR' in process.env == false && process.stdout.isTTY == true;
        case 'always':
            return true;
        case 'never':
            return false;
    }
};
const conditionalModify = (useColor) => (text, ...modifiers) => {
    return useColor ? modify(text, ...modifiers) : text;
};
function lookUpTerm(term) {
    return __awaiter(this, void 0, void 0, function* () {
        const response = yield (0,external_undici_namespaceObject.fetch)(`${base}/search/${term}`, {
            headers: {
                'User-Agent': `jisho-cli v${package_namespaceObject.i8} (${package_namespaceObject.cj.H})`,
            },
        });
        if (response.ok == false)
            throw new Error(`HTTP ${response.status}: ${response.statusText}`);
        const html = yield response.text();
        return parse(html);
    });
}
function renderInfo(supplementalInfo) {
    return supplementalInfo
        .map(x => {
        switch (x.type) {
            case 'tag':
                return x.text;
            case 'see-also':
                return `see also ${main_link(x.text, base + x.href)}`;
        }
    })
        .join(', ');
}
function main_link(text, href) {
    return `\x1b]8;;${href}\x1b\\${text}\x1b]8;;\x1b\\`;
}
main();

/******/ })()
;
//# sourceMappingURL=jisho.js.map